---
title: Get all auth methods
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Webhooks Integration
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

# Get all auth methods{% #get-all-auth-methods %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                                                            |
| ----------------- | --------------------------------------------------------------------------------------- |
| ap1.datadoghq.com | GET https://api.ap1.datadoghq.com/api/v2/integration/webhooks/configuration/auth-method |
| ap2.datadoghq.com | GET https://api.ap2.datadoghq.com/api/v2/integration/webhooks/configuration/auth-method |
| app.datadoghq.eu  | GET https://api.datadoghq.eu/api/v2/integration/webhooks/configuration/auth-method      |
| app.ddog-gov.com  | GET https://api.ddog-gov.com/api/v2/integration/webhooks/configuration/auth-method      |
| us2.ddog-gov.com  | GET https://api.us2.ddog-gov.com/api/v2/integration/webhooks/configuration/auth-method  |
| uk1.datadoghq.com | GET https://api.uk1.datadoghq.com/api/v2/integration/webhooks/configuration/auth-method |
| app.datadoghq.com | GET https://api.datadoghq.com/api/v2/integration/webhooks/configuration/auth-method     |
| us3.datadoghq.com | GET https://api.us3.datadoghq.com/api/v2/integration/webhooks/configuration/auth-method |
| us5.datadoghq.com | GET https://api.us5.datadoghq.com/api/v2/integration/webhooks/configuration/auth-method |

### Overview

Get a list of all auth methods configured for the Webhooks integration in your organization. This endpoint requires the `integrations_read` permission.

### Arguments

#### Query Strings

| Name    | Type | Description                                                                                                        |
| ------- | ---- | ------------------------------------------------------------------------------------------------------------------ |
| include | enum | Comma-separated list of relationships to include in the response. Allowed enum values: `oauth2-client-credentials` |

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response containing a list of webhooks auth methods.

| Parent field              | Field                        | Type     | Description                                                                                                    |
| ------------------------- | ---------------------------- | -------- | -------------------------------------------------------------------------------------------------------------- |
|                           | data [*required*]       | [object] | An array of webhooks auth methods.                                                                             |
| data                      | attributes [*required*] | object   | Attributes of a webhooks auth method.                                                                          |
| attributes                | protocol                     | enum     | Authentication protocol used by the auth method. Allowed enum values: `oauth2-client-credentials`              |
| data                      | id [*required*]         | string   | The ID of the auth method.                                                                                     |
| data                      | relationships                | object   | Relationships of a webhooks auth method to its protocol-specific resource.                                     |
| relationships             | oauth2-client-credentials    | object   | Relationship pointing to the OAuth2 client credentials resource for this auth method.                          |
| oauth2-client-credentials | data                         | object   | Relationship data referencing an OAuth2 client credentials resource.                                           |
| data                      | id                           | string   | The ID of the OAuth2 client credentials resource.                                                              |
| data                      | type                         | enum     | OAuth2 client credentials resource type. Allowed enum values: `webhooks-auth-method-oauth2-client-credentials` |
| data                      | type [*required*]       | enum     | Webhooks auth method resource type. Allowed enum values: `webhooks-auth-method`                                |
|                           | included                     | [object] | Resources related to the auth methods, included when requested via the `include` query parameter.              |
| included                  | attributes [*required*] | object   | OAuth2 client credentials attributes returned by the API. The `client_secret` is never echoed.                 |
| attributes                | access_token_url             | string   | URL of the OAuth2 access token endpoint.                                                                       |
| attributes                | audience                     | string   | The intended audience for the OAuth2 access token.                                                             |
| attributes                | client_id                    | string   | The OAuth2 client ID issued by the authorization server.                                                       |
| attributes                | name                         | string   | Human-readable name for this auth method.                                                                      |
| attributes                | protocol                     | enum     | Authentication protocol used by the auth method. Allowed enum values: `oauth2-client-credentials`              |
| attributes                | scope                        | string   | Space-separated list of OAuth2 scopes to request.                                                              |
| included                  | id [*required*]         | string   | The ID of the OAuth2 client credentials auth method.                                                           |
| included                  | type [*required*]       | enum     | OAuth2 client credentials resource type. Allowed enum values: `webhooks-auth-method-oauth2-client-credentials` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": [
    {
      "attributes": {
        "protocol": "oauth2-client-credentials"
      },
      "id": "596da4af-0563-4097-90ff-07230c3f9db3",
      "relationships": {
        "oauth2-client-credentials": {
          "data": {
            "id": "596da4af-0563-4097-90ff-07230c3f9db3",
            "type": "webhooks-auth-method-oauth2-client-credentials"
          }
        }
      },
      "type": "webhooks-auth-method"
    }
  ],
  "included": [
    {
      "attributes": {
        "access_token_url": "https://example.com/oauth/token",
        "audience": "https://api.example.com",
        "client_id": "my-client-id",
        "name": "my-oauth2-auth",
        "protocol": "oauth2-client-credentials",
        "scope": "read:webhooks write:webhooks"
      },
      "id": "596da4af-0563-4097-90ff-07230c3f9db3",
      "type": "webhooks-auth-method-oauth2-client-credentials"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \# Curl command curl -X GET "https://api.datadoghq.com/api/v2/integration/webhooks/configuration/auth-method" \
-H "Accept: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" 
                
##### 

```python
"""
Get all auth methods returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.webhooks_integration_api import WebhooksIntegrationApi

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = WebhooksIntegrationApi(api_client)
    response = api_instance.get_all_auth_methods()

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
##### 

```ruby
# Get all auth methods returns "OK" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::WebhooksIntegrationAPI.new
p api_instance.get_all_auth_methods()
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
##### 

```go
// Get all auth methods returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewWebhooksIntegrationApi(apiClient)
	resp, r, err := api.GetAllAuthMethods(ctx, *datadogV2.NewGetAllAuthMethodsOptionalParameters())

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `WebhooksIntegrationApi.GetAllAuthMethods`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `WebhooksIntegrationApi.GetAllAuthMethods`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
##### 

```java
// Get all auth methods returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.WebhooksIntegrationApi;
import com.datadog.api.client.v2.model.WebhooksAuthMethodsResponse;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    WebhooksIntegrationApi apiInstance = new WebhooksIntegrationApi(defaultClient);

    try {
      WebhooksAuthMethodsResponse result = apiInstance.getAllAuthMethods();
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling WebhooksIntegrationApi#getAllAuthMethods");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
##### 

```rust
// Get all auth methods returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_webhooks_integration::GetAllAuthMethodsOptionalParams;
use datadog_api_client::datadogV2::api_webhooks_integration::WebhooksIntegrationAPI;

#[tokio::main]
async fn main() {
    let configuration = datadog::Configuration::new();
    let api = WebhooksIntegrationAPI::with_config(configuration);
    let resp = api
        .get_all_auth_methods(GetAllAuthMethodsOptionalParams::default())
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
##### 

```typescript
/**
 * Get all auth methods returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.WebhooksIntegrationApi(configuration);

apiInstance
  .getAllAuthMethods()
  .then((data: v2.WebhooksAuthMethodsResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"
{% /tab %}
